import numpy as np
import cv2

camera = cv2.VideoCapture(0,cv2.CAP_DSHOW)

previous_gray = None

while True:
    hasFrame, frame = camera.read() 
    if not hasFrame: 
        break
        
    gray = cv2.cvtColor(frame,cv2.COLOR_BGR2GRAY)
    gray = cv2.GaussianBlur(gray,(21,21),0)

    if previous_gray is not None:

        delta_frame = cv2.absdiff(previous_gray,gray)
        cv2.imshow("delta Frame",delta_frame)
        
        _, thresh_frame = cv2.threshold(delta_frame, 30, 255, cv2.THRESH_BINARY)
        thresh_frame = cv2.dilate(thresh_frame, None, iterations=2)

        cnts, _ = cv2.findContours(thresh_frame.copy(),cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)

        for contour in cnts:
            if cv2.contourArea(contour) < 2000:
                continue

            x, y, w, h = cv2.boundingRect(contour)
            cv2.rectangle(frame, (x, y), (x+w, y+h), (0,255,0), 2)
            
        cv2.imshow("thresh Frame",thresh_frame)

    previous_gray = gray
        
    cv2.imshow("Color Frame",frame)

    if cv2.waitKey(10) == 27:
        break

camera.release()
cv2.destroyAllWindows()
