import numpy as np
import cv2

camera = cv2.VideoCapture(0,cv2.CAP_DSHOW)

saliency = None

while True:
    hasFrame, frame = camera.read() 
    if not hasFrame: 
        break
    
    if saliency is None:
        saliency = cv2.saliency.MotionSaliencyBinWangApr2014_create()
        saliency.setImagesize(frame.shape[1], frame.shape[0])
        saliency.init()
        
    gray = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
    _, saliencyMap = saliency.computeSaliency(gray)
    saliencyMap = (saliencyMap * 255).astype("uint8")
	
    cv2.imshow("Image", frame)
    cv2.imshow("Saliency map", saliencyMap)
    
    key = cv2.waitKey(10)
    if key ==  27:
        break
    elif key == ord('r'):
        saliency = None
        
camera.release()
cv2.destroyAllWindows()
